package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Loop2ptAlt extends JQLooper
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
  {
   // Trans is used as a second origin.  We rotate around both, averaging each time.
    FastQuaternion add = coeff.times(point);
    FastQuaternion Q0 = new FastQuaternion(point);
    
    for (int i = 1; i < depth; i++) {
      if (Q0.magnitude_sq() > 4)
        return i;
      Q0.minus_equal(trans);
      Q0.times_equal(Q0).plus_equal(add);
      Q0.plus_equal(trans);
      Q0.times_equal(Q0).plus_equal(add);
    }
    return depth;
  }
}

