/*
 * @(#)GIFDecoder.java    0.10 9/13/97 Garr Lystad, with thanks to Adam Doppelt
 */

package JavaQuat20.GIFDecoderPkg;

import java.io.*;

public class RGBxSizeSequence
  // Holds an array of bytes for a color table in the form R[0], G[0], B[0], R[1], ..., B[size-1].
{
  public byte [] byteTable = null;
  
  RGBxSizeSequence (BufferedInputStream bstream, int size) throws IOException
  {
    byteTable = new byte[size * 3];
//    System.out.println("ColorTable::ColorTable size=" + size);
    for (int i = 0; i < size * 3; i++) {
      byteTable[i] = (byte)bstream.read();
    }
  }
}

