package JavaQuat20;

import java.awt.*;
import java.awt.event.*;


class TextDialog extends Dialog
  // This is to get user comments when a picture is saved to disk or URL.
{
  TextArea textArea_;
  
  public TextDialog (String title, Frame jQFrame, String initialString)
  {
    super(jQFrame, title, true);
    setLayout(new BorderLayout(4, 10));
    textArea_ = new TextArea(initialString);
    Panel buttonBox = new Panel();
    buttonBox.setLayout(new GridLayout(1, 4, 4, 0));
      buttonBox.add(new Label());
      buttonBox.add(new Label());
      Button oK = new Button("DONE");
      oK.addActionListener(new OKLNR());
      buttonBox.add(oK);
      Button cancel = new Button("CANCEL");
      cancel.addActionListener(new CancelLNR());
      buttonBox.add(cancel);
    add("South", buttonBox);
    add("Center", textArea_);
    setSize(400, 100);
    show();
  }
  
  public String getText ()
  {
    return textArea_.getText();
  }
  
  /* -------------- Listeners ------------------ */
  
  class OKLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
    } 
  }
  
  class CancelLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
      textArea_.setText("");
    }  
  }
  
}
