package JavaQuat20;

import java.math.*;

class Utility
{

  public static String removeExponent (String string1)
    // Converts scientific notation to regular notation (removes exponent)
    // Both input and output are strings.
  {
    int eIndex = string1.indexOf('e');
    if (eIndex < 0)
      eIndex = string1.indexOf('E');
    if (eIndex < 0)
      return string1;
    String exponentStr = string1.substring(eIndex + 1);
    String mantissaStr = string1.substring(0, eIndex);
    int exponent;
    BigDecimal mantissa;
    try {
      exponent = Integer.valueOf(exponentStr).intValue();
      mantissa = new BigDecimal(mantissaStr);
    } catch (NumberFormatException ex) {
      System.err.println("Labeled_Text_Field.removeExponent error: " + ex);
      return "0.0";
    }

    return mantissa.movePointRight(exponent).toString();
  }
  
}
